const fs=require('fs');
const glob=require('glob');

function getFilesSync (options, callback) {
	var file_list=processEachFile (options, callback);
	if(callback==='function') {
		callback(file_list);
	}
	return file_list;
}

function processEachFile (options, callback) {
	if (typeof options === 'function') {
		callback = options
		options = null
	}
	var opts = setopts(options);
	var files_to_process = [];
	var arguments = process.argv.slice(opts.slice);
	for (let j = 0; j < arguments.length; j++) {
		var path = arguments[j];
		files = glob.sync(path, {nonull: true});
		if (files) {
			//console.log("globbed list: "+JSON.stringify(files));
			for (var i=0; i<files.length; i++) {
				var file=files[i];
				//console.log(file);
				if( files_to_process.indexOf(file) < 0 ) {
					if (opts.validate) {
						is_valid=false;
						try {
							var stats = fs.statSync(file);
							if (stats.isFile()) {
								if (opts.files)  {
									is_valid=true;
								} else {
									con_out(opts, file+": is a file. Skipping. Option files="+files.dirs);
								}
							} else if (stats.isDirectory) {
								if (opts.dirs)  {
									is_valid=true;
								} else {
									con_out(opts, file+": is a directory. Skipping. Option dirs="+opts.dirs);
								}
							} else {
								con_out(opts, file+": is not a file or directory. Skipping");
							}
						} catch (statEx) {
							con_out(opts, file+": not found");
						}
					} else {
						is_valid=true;
					}
					if (is_valid) {
						if(callback==='function') {
							callback(file);
						}
						files_to_process.push(file);
					}
					
				} else {
					con_out(opts, file+": duplicate");
				}
			}
		}
	}
	if(callback) {
		callback(files_to_process);
	}
	return(files_to_process);
}

// export the module
module.exports = {
    getFilesSync: getFilesSync,
    processEachFile: processEachFile
};

function con_out(opts, data) {
	if (opts.verbose) {
		console.log(data);
	}
}

function setopts (options) {
	var opts = {
		slice: 2,
		verbose: false,
		validate: true,
		files: true,
		dirs: false
	};
	if (!options)
		options = {};

	if ( !isNaN(options.slice) ) { 
		opts.slice = options.slice;
	} 
	if (typeof options.verbose === "boolean" ) {
		opts.verbose = options.verbose;
	} 
	if (typeof options.validate === "boolean") {
		opts.validate = options.validate;
	} 
	if (typeof options.files === "boolean") {
		opts.files = options.files;
	} 
	if (typeof options.dirs === "boolean") {
		opts.dirs = options.dirs;
	} 
	return opts;
}